/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.init;

import java.util.function.Supplier;
import net.minecraft.class_1832;
import net.minecraft.class_1856;
import net.minecraft.class_3528;

//TODO: Use tags
public enum TRToolTier implements class_1832 {
	BRONZE(2, 375, 6.0f, 2.25f, 8, () -> {
		return class_1856.method_8091(TRContent.Ingots.BRONZE.method_8389());
	}), RUBY(2, 320, 6.2F, 2.7F, 10, () -> {
		return class_1856.method_8091(TRContent.Gems.RUBY.method_8389());
	}), SAPPHIRE(3, 620, 5.0F, 2F, 8, () -> {
		return class_1856.method_8091(TRContent.Gems.SAPPHIRE.method_8389());
	}), PERIDOT(2, 400, 7.0F, 2.4F, 16, () -> {
		return class_1856.method_8091(TRContent.Gems.PERIDOT.method_8389());
	});

	/**
	 * The level of material this tool can harvest (3 = DIAMOND, 2 = IRON, 1 =
	 * STONE, 0 = WOOD/GOLD)
	 */
	private final int harvestLevel;
	/**
	 * The number of uses this material allows. (wood = 59, stone = 131, iron = 250,
	 * diamond = 1561, gold = 32)
	 */
	private final int maxUses;
	/**
	 * The strength of this tool material against blocks which it is effective
	 * against.
	 */
	private final float efficiency;
	/** Damage versus entities. */
	private final float attackDamage;
	/** Defines the natural enchantability factor of the material. */
	private final int enchantability;
	private final class_3528<class_1856> repairMaterial;

	private TRToolTier(int harvestLevelIn, int maxUsesIn, float efficiencyIn, float attackDamageIn,
			int enchantabilityIn, Supplier<class_1856> repairMaterialIn) {
		this.harvestLevel = harvestLevelIn;
		this.maxUses = maxUsesIn;
		this.efficiency = efficiencyIn;
		this.attackDamage = attackDamageIn;
		this.enchantability = enchantabilityIn;
		this.repairMaterial = new class_3528<>(repairMaterialIn);
	}

	@Override
	public int method_8025() {
		return maxUses;
	}

	@Override
	public float method_8027() {
		return efficiency;
	}

	@Override
	public float method_8028() {
		return attackDamage;
	}

	@Override
	public int method_8024() {
		return harvestLevel;
	}

	@Override
	public int method_8026() {
		return enchantability;
	}

	@Override
	public class_1856 method_8023() {
		return repairMaterial.method_15332();
	}
}
