/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.init.recipes;

import techreborn.items.ItemDynamicCell;

import java.security.InvalidParameterException;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2246;

/**
 * Created by Prospector
 */
public class IndustrialCentrifugeRecipes extends RecipeMethods {
	public static void init() {

		register(getStack(class_2246.field_10566, 16), 2500, getStack(class_2246.field_10102, 8), getStack(class_1802.field_8696), getStack(class_2246.field_10255, 2));
		register(getStack(class_2246.field_10479, 16), 2500, getStack(class_2246.field_10102, 8), getStack(class_1802.field_8696), getStack(class_2246.field_10255, 2), getStack(class_1802.field_8317, 4));
		register(getStack(class_2246.field_10402, 8), 1640, getStack(class_2246.field_10102, 4), getStack(class_1802.field_8696), getStack(class_2246.field_10251, 2), getStack(class_2246.field_10559, 2));
		register(getStack(class_1802.field_8463), 5000, getStack(class_1802.field_8695, 6), getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8367), 5000, getStack(class_1802.field_8695, 64), getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8071), 5000, getStack(class_1802.field_8397, 6), getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8597, 8), 5000, getStack(class_1802.field_8397, 6), getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8279, 32), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8208, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8229, 64), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8389, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8261, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8046, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8176, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8726, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8544, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8748, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8347, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8504, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8752, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8429, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8373, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8209, 12), 5000, getMaterial("methane", Type.CELL));		
		register(getStack(class_1802.field_8509, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8497, 64), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_2246.field_10261, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8511, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8680, 32), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8179, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8567, 16), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8635, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8512, 24), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8186, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8423, 64), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_2246.field_10580, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_2246.field_10240, 12), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_2246.field_10251, 32), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_2246.field_10559, 32), 5000, getMaterial("methane", Type.CELL));
		register(getStack(class_1802.field_8790, 32), 5000, getMaterial("methane", Type.CELL));
//TODO: Fixme		
//		register(getMaterial("sap", 4, Type.PART), 1300, getMaterial("rubber", 14, Type.PART));
//		register(getStack(ModBlocks.RUBBER_LOG, 16), 5000, false, getMaterial("sap", 8, Type.PART), getMaterial("methane", Type.CELL), getMaterial("carbon", 4, Type.CELL));
//		register(getStack(Blocks.SOUL_SAND, 16), 2500, getStack(Blocks.SAND, 10), getMaterial("saltpeter", 4, Type.DUST), getMaterial("coal", Type.DUST), getMaterial("oil", Type.CELL));
//		register(getOre("dustBronze"), 1500, getMaterial("copper", 6, Type.SMALL_DUST), getMaterial("tin", 2, Type.SMALL_DUST));
//		register(getOre("dustIron", 2), 1500, getMaterial("tin", Type.SMALL_DUST), getMaterial("nickel", Type.SMALL_DUST));
//		register(getOre("dustSilver", 2), 2400, getMaterial("lead", Type.SMALL_DUST));
//		register(getOre("dustLead", 2), 2400, getMaterial("silver", Type.SMALL_DUST));
//		register(getOre("dustTin", 2), 210, getMaterial("zinc", Type.SMALL_DUST), getMaterial("iron", Type.SMALL_DUST));
//		register(getOre("dustElectrum"), 960, getMaterial("gold", 2, Type.SMALL_DUST), getMaterial("silver", 2, Type.SMALL_DUST));
//		register(getOre("dustZinc"), 1040, getMaterial("tin", Type.SMALL_DUST));
//		register(getOre("dustBrass"), 1500, getMaterial("copper", 3, Type.SMALL_DUST), getMaterial("zinc", Type.SMALL_DUST));
//		register(getOre("dustPlatinum", 2), 3000, getMaterial("iridium", 2, Type.NUGGET), getMaterial("nickel", Type.SMALL_DUST));
//		register(getOre("dustNickel", 3), 3440, getMaterial("iron", Type.SMALL_DUST), getMaterial("gold", Type.SMALL_DUST), getMaterial("copper", Type.SMALL_DUST));
//		register(getOre("dustGold", 3), 2400, getMaterial("copper", Type.SMALL_DUST), getMaterial("nickel", Type.SMALL_DUST));
//		register(getOre("dustCopper", 3), 2400, getMaterial("gold", Type.SMALL_DUST), getMaterial("nickel", Type.SMALL_DUST));
//		register(getOre("dustRedstone", 32), 2200, getMaterial("silicon", 3, Type.CELL), getMaterial("pyrite", 16, Type.DUST), getMaterial("ruby", 3, Type.DUST), getMaterial("mercury", 10, Type.CELL));
//		register(getOre("dustGlowstone", 16), 2500, getStack(Items.REDSTONE, 8), getMaterial("sulfur", Type.CELL), getMaterial("helium", Type.CELL));
//		register(getStack(Items.DYE, 4, 4), 1500, false, getMaterial("lazurite", 3, Type.DUST), getMaterial("pyrite", Type.SMALL_DUST), getMaterial("calcite", Type.SMALL_DUST), getMaterial("sodalite", 2, Type.SMALL_DUST));
//		register(getOre("dustEnderEye", 2), 1840, getMaterial("ender_pearl", 2, Type.DUST), getStack(Items.BLAZE_POWDER));
//		register(getOre("dustNetherrack", 16), 2400, getStack(Items.REDSTONE), getMaterial("sulfur", Type.CELL), getMaterial("coal", Type.DUST), getStack(Items.GOLD_NUGGET));
//		register(getOre("dustEndstone", 16), 4800, getMaterial("helium3", Type.CELL), getMaterial("helium", Type.CELL), getMaterial("tungsten", Type.SMALL_DUST), getStack(Blocks.SAND, 12));
//		register(getOre("dustRedGarnet", 16), 3000, getMaterial("pyrope", 3, Type.DUST), getMaterial("almandine", 5, Type.DUST), getMaterial("spessartine", 8, Type.DUST));
//		register(getOre("dustYellowGarnet", 16), 3500, getMaterial("andradite", 5, Type.DUST), getMaterial("grossular", 8, Type.DUST), getMaterial("uvarovite", 3, Type.DUST));
//		register(getOre("dustDarkAshes", 2), 240, getMaterial("ashes", 1, Type.DUST));
//		register(getOre("dustAshes", 2), 240, getMaterial("carbon", Type.CELL));
//		register(getOre("dustMarble"), 1040, getMaterial("magnesium", Type.DUST), getMaterial("calcite", 7, Type.DUST));
//		register(getOre("dustBasalt", 16), 2040, getMaterial("peridot", Type.DUST), getMaterial("calcite", 3, Type.DUST), getMaterial("flint", 8, Type.DUST), getMaterial("dark_ashes", 4, Type.DUST));
//		register(getMaterial("lava", 16, Type.CELL), 1500, getMaterial("tin", 6, Type.INGOT), getMaterial("copper", 4, Type.INGOT), getMaterial("electrum", Type.INGOT), getMaterial("tungsten", Type.SMALL_DUST));
		register(getMaterial("hydrogen", 4, Type.CELL), 3000, getMaterial("deuterium", Type.CELL));
		register(getMaterial("deuterium", 4, Type.CELL), 3000, getMaterial("tritium", Type.CELL));
		register(getMaterial("helium", 16, Type.CELL), 5000, getMaterial("helium3", Type.CELL));
//		register(getMaterial("calciumcarbonate", Type.CELL), 40, getMaterial("calcite", Type.DUST));
//		register(getMaterial("sulfur", Type.CELL), 40, getMaterial("sulfur", Type.DUST));
	}

	static void register(Object input, int ticks, boolean oreDict, class_1799... outputs) {
		class_1799 output1;
		class_1799 output2 = null;
		class_1799 output3 = null;
		class_1799 output4 = null;

		if (outputs.length == 3) {
			output1 = outputs[0];
			output2 = outputs[1];
			output3 = outputs[2];
		} else if (outputs.length == 2) {
			output1 = outputs[0];
			output2 = outputs[1];
		} else if (outputs.length == 1) {
			output1 = outputs[0];
		} else if (outputs.length == 4) {
			output1 = outputs[0];
			output2 = outputs[1];
			output3 = outputs[2];
			output4 = outputs[3];
		} else {
			throw new InvalidParameterException("Invalid industrial centrifuge outputs: " + outputs);
		}

		int cellCount = 0;
		for (class_1799 stack : outputs) {
			if (stack.method_7909() instanceof ItemDynamicCell) {
				cellCount += stack.method_7947();
			}

		}

		if (input instanceof class_1799) {
			if (((class_1799) input).method_7909() instanceof ItemDynamicCell) {
				int inputCount = ((class_1799) input).method_7947();
				if (cellCount < inputCount) {
					if (output2 == null) {
						output2 = ItemDynamicCell.getEmptyCell(inputCount - cellCount);
					} else if (output3 == null) {
						output3 = ItemDynamicCell.getEmptyCell(inputCount - cellCount);
					} else if (output4 == null) {
						output4 = ItemDynamicCell.getEmptyCell(inputCount - cellCount);
					}
				}
				cellCount -= inputCount;

			}
		}

		if (cellCount < 0) {
			cellCount = 0;
		}
		class_1799 cells = null;
		if (cellCount > 0) {
			if (cellCount > 64) {
				throw new InvalidParameterException("Invalid industrial centrifuge outputs: " + outputs + "(Recipe requires > 64 cells)");
			}
			cells = ItemDynamicCell.getEmptyCell(cellCount);
		}
		//RecipeHandler.addRecipe(Reference.CENTRIFUGE_RECIPE, new CentrifugeRecipe(input, cells, output1, output2, output3, output4, ticks, 5, oreDict));
	}

	static void register(Object input, int ticks, class_1799... outputs) {
		register(input, ticks, true, outputs);
	}
}
