/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.utils;

import io.github.prospector.silk.fluid.FluidInstance;
import reborncore.common.fluid.container.GenericFluidContainer;
import reborncore.mixin.extensions.FluidBlockExtensions;

import java.util.List;
import java.util.stream.Collectors;
import net.minecraft.class_1263;
import net.minecraft.class_1799;
import net.minecraft.class_2248;
import net.minecraft.class_2350;
import net.minecraft.class_2378;
import net.minecraft.class_3611;
import net.minecraft.class_3612;

public class FluidUtils {

	public static class_3611 fluidFromBlock(class_2248 block){
		if(block instanceof FluidBlockExtensions){
			return ((FluidBlockExtensions) block).getFluid();
		}
		return class_3612.field_15906;
	}

	public static List<class_3611> getAllFluids() {
		return class_2378.field_11154.method_10220().collect(Collectors.toList());
	}

	public static boolean drainContainers(GenericFluidContainer<class_2350> target, class_1263 inventory, int inputSlot, int outputSlot) {
		class_1799 inputStack = inventory.method_5438(inputSlot);
		class_1799 outputStack = inventory.method_5438(outputSlot);

		if (inputStack.method_7960()) return false;

		if(inputStack.method_7947() > 1){
			System.out.println("TODO make this support more than 1 item");
			return false;
		}

		if (outputStack.method_7947() >= outputStack.method_7914()) return false;

		GenericFluidContainer<class_1799> source = GenericFluidContainer.fromStack(inputStack);
		if(source == null || source.getFluidInstance(inputStack).isEmpty()){
			return false;
		}

		class_3611 fluidType = source.getFluidInstance(inputStack).getFluid();
		FluidInstance contained = target.getFluidInstance(null);

		if(!contained.isEmpty()){
			//Check that the fluid we are trying to insert into is the same
			if(contained.getFluid() != fluidType){
				return false;
			}
		}

		int transferAmount = 10;

		if(source.canExtractFluid(inputStack, fluidType, transferAmount) && target.canInsertFluid(null, fluidType, transferAmount)){
			target.insertFluid(null, fluidType, transferAmount);
			source.extractFluid(inputStack, fluidType, transferAmount);
			if(source.getCurrentFluidAmount(inputStack) < 1){
				inventory.method_5447(outputSlot, inputStack);
				inventory.method_5447(inputSlot, class_1799.field_8037);
			}
			return true;
		}

		return false;
	}

	public static boolean fillContainers(GenericFluidContainer<class_2350> source, class_1263 inventory, int inputSlot, int outputSlot, class_3611 fluidToFill) {
		return false;
	}

	public static boolean fluidEquals(class_3611 fluid, class_3611 fluid1) {
		return false;
	}

	public static FluidInstance getFluidStackInContainer(class_1799 invStack) {
		return null;
	}
}
